// Copyright (c)1995 Ray Dream, Inc. All Rights Reserved.
/* $Id: ShdrFac.h 1.1 1996/07/19 00:15:33 Damien Exp $ */

// Class factories

#ifndef __SHDRFAC__
#define __SHDRFAC__

#ifndef __I3DEX__
#include "I3DEX.H"
#endif 


// Class Factory : used to create the RainbowShader Object

class RainbowClassFactory : public IClassFactory {
public:
  RainbowClassFactory(void);
  ~RainbowClassFactory(void);

  //IUnknown members
  STDMETHODIMP         QueryInterface(REFIID, LPVOID FAR*);
  STDMETHODIMP_(ULONG) AddRef(void);
  STDMETHODIMP_(ULONG) Release(void);

  //IClassFactory members
  STDMETHODIMP         CreateInstance(LPUNKNOWN, REFIID, LPVOID FAR*);
  STDMETHODIMP         LockServer(BOOL);
protected:
  ULONG           m_cRef;
	};

// Class Factory : used to create the CheckerShader Object

class CheckerClassFactory : public IClassFactory {
public:
  CheckerClassFactory(void);
  ~CheckerClassFactory(void);

  //IUnknown members
  STDMETHODIMP         QueryInterface(REFIID, LPVOID FAR*);
  STDMETHODIMP_(ULONG) AddRef(void);
  STDMETHODIMP_(ULONG) Release(void);

  //IClassFactory members
  STDMETHODIMP         CreateInstance(LPUNKNOWN, REFIID, LPVOID FAR*);
  STDMETHODIMP         LockServer(BOOL);
protected:
  ULONG           m_cRef;
	};

#endif

